import React from "react";
import { dequeue, clearQueueHook } from "./queue.js";
import { SpeechStatus, useSpeechProps, SpeechUtterancesQueue } from "./types.js";
export declare function useQueue(): {
    queue: SpeechUtterancesQueue;
    dequeue: typeof dequeue;
    clearQueue: typeof clearQueueHook;
};
export declare function useSpeech({ text, pitch, rate, volume, lang, voiceURI, highlightText, highlightProps, preserveUtteranceQueue, onError, onStart, onResume, onPause, onStop, onBoundary, onQueueChange, }: useSpeechProps): {
    Text: () => React.ReactNode;
    speechStatus: SpeechStatus;
    isInQueue: boolean;
    start: () => any;
    pause: () => void;
    stop: () => void;
};
