import { isValidElement } from "react";
export function ArrayToText(element) {
    if (typeof element === "string")
        return element;
    return element.map(ArrayToText).join(" ") + " ";
}
export function JSXToArray(element) {
    if (isValidElement(element)) {
        const { children } = element.props;
        if (Array.isArray(children))
            return children.map(JSXToArray);
        return JSXToArray(children);
    }
    return typeof element === "string" ? element : typeof element === "number" ? String(element) : "";
}
export function cancel() {
    var _a;
    if (typeof window !== "undefined")
        (_a = window.speechSynthesis) === null || _a === void 0 ? void 0 : _a.cancel();
}
export function findCharIndex(words, index) {
    let currentIndex = 0;
    function recursiveSearch(stringArray, parentIndex = "") {
        if (typeof stringArray === "string") {
            const elementIndex = index - currentIndex;
            return (currentIndex += stringArray.length + 1) > index ? getIndex(parentIndex, elementIndex) : "";
        }
        for (let i = 0; i < stringArray.length; i++) {
            const element = stringArray[i];
            const result = recursiveSearch(element, i);
            if (result)
                return getIndex(parentIndex, result);
        }
        currentIndex++;
        return "";
    }
    return recursiveSearch(words);
}
export function getIndex(parentIndex, index) {
    return `${parentIndex === "" ? "" : parentIndex + "-"}${index}`;
}
export function isParent(parentIndex, index) {
    if (!(index === null || index === void 0 ? void 0 : index.startsWith(parentIndex)))
        return false;
    if (parentIndex) {
        const indexParts = index.split("-");
        const parentIndexParts = parentIndex.split("-");
        for (let i = 0; i < parentIndexParts.length; i++) {
            if (indexParts[i] !== parentIndexParts[i])
                return false;
        }
    }
    return true;
}
export const sanitize = (text) => text.replace(/[;<>]/g, (match) => (match === ">" ? ")" : "("));
